<?xml version="1.0"?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">
  <xsl:param name="projectName" select="' '"/>

  <xsl:template match="esc">
<html>
<head>
<title>XML Console report - <xsl:value-of select="$projectName"/> </title>
<style type="text/css">
<!--
h1 {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18pt; color: #000000}
-->
</style>
</head>

<body bgcolor="#FFFFFF" marginheight="0" marginwidth="0" topmargin="0" leftmargin="0">
<table width="90%" border="0" cellspacing="0" cellpadding="6" align="center">
  <tr> 
    <td  align="left" valign="top"> 
      <h1>XML Console Project Report -  <xsl:value-of select="$projectName"/> </h1>
      </td>
  </tr>
</table>
	<xsl:apply-templates/>
</body>
</html>
  </xsl:template>

  <xsl:template match="file">
   <xsl:choose>
    	<xsl:when test="./recurse" >
    			<xsl:apply-templates mode="directory" select="."/>
    	</xsl:when>
    	<xsl:otherwise>
    			<xsl:apply-templates mode="file" select="."/>
    	</xsl:otherwise>
    </xsl:choose>
  </xsl:template>
<xsl:template mode="file" match="file">

<table width="90%" border="0" cellspacing="1" cellpadding="1" bordercolor="#FFFFFF" bordercolordark="#FFFFFF" bordercolorlight="#FFFFFF" align="center" >
  <tr> 
    <td rowspan="2" bgcolor="#000066" align="left" valign="top" width="3%"><font color="#FFFFFF" face="Verdana, Arial, Helvetica, sans-serif" size="2">
    	    <b>File</b>
	</font></td>
    <td colspan="2" bgcolor="#eeeeee" valign="top" width="97%"> 
      <p><b><font color="#000066" face="Verdana, Arial, Helvetica, sans-serif">
<xsl:value-of select="@name" /></font></b></p>
    </td>
  </tr>
  <tr> 
    <td colspan="2" bgcolor="#eeeeee" align="left" valign="top" width="97%"> 
      <table width="100%" border="0" cellspacing="0" cellpadding="0" bordercolor="#FFFFFF" bordercolorlight="#FFFFFF" bordercolordark="#FFFFFF">
        <tr align="left" valign="top"> 
          <td colspan="3" valign="top"> <font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b>Status</b>:</font> 
            <font size="2" face="Verdana, Arial, Helvetica, sans-serif">

		<xsl:if test="@valid='false'">
			 <font color="red"><b> Not Valid </b></font>
		</xsl:if>
		<xsl:if test="@valid='true'">
			<b>Valid </b>
		</xsl:if>

		</font> 
            </td>
          <td colspan="2" valign="top" width="79%"> 
            <div align="right"><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Validation 
              Time: </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">
		<xsl:value-of select="@date" /> </font></div>
          </td>
        </tr>

		<xsl:if test="./error">

        <tr align="left" valign="top"> 
          <td width="9%">&#160;</td>
          <td colspan="4"> 
            <table width="100%" border="2" cellspacing="0" cellpadding="3" bordercolor="#FFFFFF">
              <tr align="left" valign="top" bgcolor="#CCCCCC"> 
                <td colspan="2"><big><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>
		<font color="#660000">Errors</font></b></font></big></td>
              </tr>
              <tr> 
                <td width="10%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif">
			<b>Location</b> </font></td>
                <td width="90%"> 
                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b>Description</b></font><font size="2"></font></p>
                </td>
              </tr>

<xsl:apply-templates mode="errors"/>
             </table>
          </td>
        </tr>
		</xsl:if>	

       </table>
    </td>
  </tr>
</table>
<P/>
  </xsl:template>
  
<xsl:template mode="directory" match="file">

<table width="90%" border="0" cellspacing="1" cellpadding="1" bordercolor="#FFFFFF" bordercolordark="#FFFFFF" bordercolorlight="#FFFFFF" align="center" >
  <tr> 
    <td rowspan="2" bgcolor="#000066" align="left" valign="top" width="3%"><font color="#FFFFFF" face="Verdana, Arial, Helvetica, sans-serif" size="2">
    	    <b>Directory</b>
	</font></td>
    <td colspan="2" bgcolor="#eeeeee" align="left" valign="top" width="97%"> 
      <p><b><font color="#000066" face="Verdana, Arial, Helvetica, sans-serif">
<xsl:value-of select="@name" /></font></b></p>
    </td>
  </tr>
  <tr> 
    <td colspan="2" bgcolor="#eeeeee" align="left" valign="top" width="97%"> 
      <table width="100%" border="0" cellspacing="0" cellpadding="0" bordercolor="#FFFFFF" bordercolorlight="#FFFFFF" bordercolordark="#FFFFFF">
        <tr align="left" valign="top"> 
    <td  bgcolor="#eeeeee"  align="right" valign="top" > 
      <p><b><font size="2" face="Verdana, Arial, Helvetica, sans-serif">
			Recurse: <xsl:value-of select="./recurse" /></font></b></p>
    </td>

          <td colspan="2" valign="top" align="left"> 
            <div align="right"><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Validation 
              Time: </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">
		<xsl:value-of select="@date" /> </font></div>
          </td>
        </tr>

       </table>
    </td>
  </tr>
</table>
<P/>
  </xsl:template>


  <xsl:template mode="errors" match="error">
      <tr>
<xsl:apply-templates mode="errors"/>
      </tr>
  </xsl:template>

  <xsl:template mode="errors" match="message">
            <td width="90%">   <xsl:value-of select="." /> </td>
  </xsl:template>

  <xsl:template mode="errors" match="location">
            <td width="10%">   <xsl:value-of select="." /> </td>
  </xsl:template>


</xsl:stylesheet>
